<?php
//System Configuration
define('PJP_CLASS_EXTENSION', '.php');
define('PJP_PLUGIN_MANIFEST', 'plugin.desc');
define('PJP_CORE_PLUGIN', 'pjp.core');

//Set the base path to the path where PJP is located
define('PJP_BASE_PATH', 'D:/wampserver/PJP');

define('PJP_PLATFORM_PATH', PJP_BASE_PATH . '/platform');
define('PJP_APPLICATION_PATH', PJP_BASE_PATH . '/application');
define('PJP_CLASS_CACHE_PATH', PJP_BASE_PATH . '/classcache');
define('PJP_CORE_PATH', PJP_PLATFORM_PATH . '/' . PJP_CORE_PLUGIN);

//Set include path to core plugin
set_include_path(PJP_CORE_PATH);

//Include the class loader and error handler
require_once('pjp/core/classmanagement/pjpclassloader.php');
require_once('pjp/core/errorhandling/errorhandler.php');

//Register class autoloader methods
spl_autoload_extensions(PJP_CLASS_EXTENSION);
spl_autoload_register('\pjp\core\classmanagement\PJPClassLoader::loadClassFromCache');
spl_autoload_register('\pjp\core\classmanagement\PJPClassLoader::loadClass');
spl_autoload_register('\pjp\core\classmanagement\PJPClassLoader::classNotFound');

//Register error/exception handler and the default handler action
set_error_handler('\pjp\core\errorhandling\ErrorHandler::handleError');
set_exception_handler('\pjp\core\errorhandling\ErrorHandler::handleException');
\pjp\core\errorhandling\ErrorHandler::addHandlerAction('\pjp\core\errorhandling\PJPExceptionActions::shh');

//Bootstrap core plugin
\pjp\core\pluginmanagement\PJPPluginLoader::load(PJP_CORE_PLUGIN);

//Final Ops
?>