<?php
namespace pjp\core\classmanagement;

use Exception;

/**
 * Specialized exception to be thrown when there is a class-related exception.
 * Factory methods have been provided to ensure standardized error messages.
 */
class ClassException extends Exception {
	const CLASS_LOADING_FAILED = "Unable to load class '%s'";

	public function __construct($message, $previous = null) {
		parent::__construct($message, 0, $previous);
	}

	public static function loadingFailed($class, $previous = null) {
		return self::createException(self::CLASS_LOADING_FAILED, $class, $previous);
	}

	private static function createException($exceptionstring, $class, $previous) {
		$message = sprintf($exceptionstring, $class);
		return new self($message, $previous);
	}

}

?>