<?php
namespace pjp\core\errorhandling;

use Exception;

/**
 * Defines some basic behaviour to be taken when an exception is trapped.
 * You can register these functions through the error handler.
 */
class PJPExceptionActions {

	/**
	 * Basic dump of the exception trace.
	 */
	public static function dump(Exception $exception) {
		do {
			printf( "[%s] at %s:%d %s\n", get_class($exception), $exception->getFile(), $exception->getLine(), $exception->getMessage() );
		} while( $exception = $exception->getPrevious() );
	}

	/**
	 * Don't tell anyone
	 */
	public static function shh(Exception $exception) {
		//shh
	}

}

?>