<?php
namespace pjp\core\pluginmanagement;

use pjp\core\interfaces\Accessor;

/**
 * Stores the descriptive details of a plugin and implements the Accessor interface
 * to allow for easy access to the fields. Plugins are immutable objects that must be created via
 * the factory method.
 */
class Plugin implements Accessor {
	private $name;
	private $id;
	private $version;
	private $activator;
	private $dependancies;

	private function __construct($name, $id, $version, $activator, array $dependancies) {
		$this->name = $name;
		$this->id = $id;
		$this->version = $version;
		$this->activator = $activator;
		$this->dependancies = $dependancies;
	}

	public static function createPlugin($name, $id, $version, $activator, array $dependancies) {
		return new self($name, $id, $version, $activator, $dependancies);
	}

	public function __get($fieldname) {
		return $this->{$fieldname};
	}

}

?>