<?php
namespace pjp\core\tools;

/**
 * Utility class that provides platform-independant methods for building relevant path strings.
 */
class PathBuilder {
	/**
	 * Implodes arguments into a path string. An array of strings can also be supplied instead.
	 */
	public static function buildPath($tokens) {
		$pathtokens;

		if(func_num_args() == 1)
			$pathtokens = $tokens;
		else
			$pathtokens = func_get_args();

		return implode('/', $pathtokens);
	}

	/**
	* Build a fully qualified path with the PJP platform directory as root.
	*/
	public static function buildPlatformPath() {
		$pathtokens = func_get_args();
		array_unshift($pathtokens, PJP_PLATFORM_PATH);
		return self::buildPath($pathtokens);
	}

	/**
	* Build a fully qualified path with the PJP application directory as root.
	*/
	public static function buildApplicationPath() {
		$pathtokens = func_get_args();
		array_unshift($pathtokens, PJP_APPLICATION_PATH);
		return self::buildPath($pathtokens);
	}

}

?>