<?php
namespace pjp\core\xmlprocessing;

/**
 * Interface that defines a correct XML handler to be used with XML Parser
 */
interface XMLParseHandler {

	public function characterDataHandler(XMLParser $parser, $data);

	public function defaultHandler(XMLParser $parser, $data);

	public function startElementHandler(XMLParser $parser, $elementname, $attribs);

	public function endElementHandler(XMLParser $parser, $elementname);

	public function startNamespaceHandler(XMLParser $parser, $prefix, $uri);

	public function endNamespaceHandler(XMLParser $parser, $prefix, $uri);

	public function externalEntityRefHandler(XMLParser $parser, $openentitynames, $base, $systemid, $publicid);

	public function unparsedEntityHandler(XMLParser $parser, $entityname, $base, $systemid, $publicid, $notationname);

	public function notationHandler(XMLParser $parser, $notationname, $base, $systemid, $publicid);

	public function processingInstructionHandler(XMLParser $parser, $target, $data);

}

?>
