<?php
namespace pjp\mvc\dispatch;

use pjp\core\interfaces\Accessor;
/**
 * Class that provides a nice wrapper for the request parameters. Supports redirected/deferred requests.
 * Uses the accessor pattern to conveniently access parameters
 */
class Request implements Accessor {
	private $path;
	private $get;
	private $post;
	private $cookies;
	private $redirectedfrom;

	/**
	 * Creates a Request object, using the environment to set the request parameters
	 */
	public static function getRequest() {
		return self::createRequestFromParameters('', null);
	}

	/**
	 * Creates a Request object, using the specified path, and optional redirected request.
	 */
	public static function createRequestFromParameters($path, Request $redirectedfrom = null) {
		return new self($path, $redirectedfrom);
	}

	private function __construct($path, Request $redirectedfrom = null) {
		$this->path = $path or $this->path = $_SERVER['PATH_INFO'];
		$this->get = $this->get = $_GET;
		$this->post = $this->post = $_POST;
		$this->cookies = $this->cookies = $_COOKIE;
		$this->redirectedfrom = $redirectedfrom;
	}

	public function __get($name) {
		return $this->$name;
	}

}

?>